unit Matrizenrechnung;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ESpalten: TEdit;
    Label5: TLabel;
    EZeilen: TEdit;
    BMatrizenErzeugen: TButton;
    SGMatrix1: TStringGrid;
    SGMatrix2: TStringGrid;
    BRechnen: TButton;
    SGAddition: TStringGrid;
    SGSubtraktion: TStringGrid;
    Label6: TLabel;
    Label7: TLabel;
    BSchliessen: TButton;
    BLoeschen: TButton;
    procedure BMatrizenErzeugenClick(Sender: TObject);
    procedure BSchliessenClick(Sender: TObject);
    procedure BLoeschenClick(Sender: TObject);
    procedure BRechnenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;


var
  Form1: TForm1;
  spalten, zeilen: integer;

implementation

{$R *.dfm}

procedure TForm1.BMatrizenErzeugenClick(Sender: TObject);
begin
  if (ESpalten.Text ='') or (EZeilen.Text = '') then
    ShowMessage('Bitte geben Sie Zeilen- und Spaltenanzahl ein!')
  else begin
  spalten := StrToInt(ESpalten.Text);
  zeilen := StrToInt(EZeilen.Text);
  SGMatrix1.ColCount := spalten;
  SGMatrix1.RowCount := zeilen;
  SGMatrix2.ColCount := spalten;
  SGMatrix2.RowCount := zeilen;
  SGMatrix1.Width := spalten*40;
  SGMatrix1.Height := zeilen*24;
  SGMatrix2.Width := spalten*40;
  SGMatrix2.Height := zeilen*24;
  SGMatrix1.Visible := True;
  SGMAtrix2.Visible := True;
  end;
end;

procedure TForm1.BSchliessenClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.BLoeschenClick(Sender: TObject);
var z,s: integer;
begin
  ESpalten.Clear;
  EZeilen.Clear;
  SGMatrix1.Visible := False;
  SGMatrix2.Visible := False;
  SGAddition.Visible := False;
  SGSubtraktion.Visible := False;
  with SGAddition do for z := 1 to zeilen do
    for s := 1 to spalten do Cells[s-1,z-1] := '';
  with SGSubtraktion do for z := 1 to zeilen do
    for s := 1 to spalten do Cells[s-1,z-1] := '';
  with SGMatrix1 do for z := 1 to zeilen do
    for s := 1 to spalten do Cells[s-1,z-1] := '';
  with SGMatrix2 do for z := 1 to zeilen do
    for s := 1 to spalten do Cells[s-1,z-1] := '';
end;

procedure TForm1.BRechnenClick(Sender: TObject);
type
  matrix = array[1..5,1..5] of double;
var
  matrix1, matrix2, matrixadd, matrixsub: matrix;
  s,z: integer;
begin
  with SGMatrix1 do for z := 1 to RowCount do
    for s := 1 to ColCount do matrix1[s,z] := StrToFloat(Cells[s-1,z-1]);
  with SGMatrix2 do for z := 1 to RowCount do
    for s := 1 to ColCount do matrix2[s,z] := StrToFloat(Cells[s-1,z-1]);
  for z := 1 to zeilen do
    for s := 1 to spalten do begin
      matrixadd[s,z] := matrix1[s,z] + matrix2[s,z];
      matrixsub[s,z] := matrix1[s,z] - matrix2[s,z];
    end;
  SGAddition.ColCount := spalten;
  SGAddition.RowCount := zeilen;
  SGSubtraktion.ColCount := spalten;
  SGSubtraktion.RowCount := zeilen;
  SGAddition.Width := spalten*40;
  SGAddition.Height := zeilen*24;
  SGSubtraktion.Width := spalten*40;
  SGSubtraktion.Height := zeilen*24;
  SGAddition.Visible := True;
  SGSubtraktion.Visible := True;
  with SGAddition do for z := 1 to RowCount do
    for s := 1 to ColCount do Cells[s-1,z-1] := FloatToStrF(matrixadd[s,z],ffFixed,4,2);
  with SGSubtraktion do for z := 1 to RowCount do
    for s := 1 to ColCount do Cells[s-1,z-1] := FloatToStrF(matrixsub[s,z],ffFixed,4,2);


end;

end.
